/*
 * SPDX-License-Identifier: Apache-2.0
 *
 * Copyright 2015-2019 Andres Almiray
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.kordamp.ikonli.devicons;

import org.kordamp.ikonli.Ikon;

/**
 * @author Andres Almiray
 */
public enum Devicons implements Ikon {
    // latest is e6c5
    ANDROID("di-android", '\ue60e'),
    ANGULAR("di-angular", '\ue653'),
    APPCELERATOR("di-appcelerator", '\ue6ab'),
    APPLE("di-apple", '\ue611'),
    APPSTORE("di-appstore", '\ue613'),
    APTANA("di-aptana", '\ue699'),
    ASTERISK("di-asterisk", '\ue6ac'),
    ATLASSIAN("di-atlassian", '\ue65b'),
    ATOM("di-atom", '\ue664'),
    AWS("di-aws", '\ue6ad'),
    BACKBONE("di-backbone", '\ue652'),
    BING_SMALL("di-bing_small", '\ue600'),
    BINTRAY("di-bintray", '\ue694'),
    BITBUCKET("di-bitbucket", '\ue603'),
    BLACKBERRY("di-blackberry", '\ue623'),
    BOOTSTRAP("di-bootstrap", '\ue647'),
    BOWER("di-bower", '\ue64d'),
    BRACKETS("di-brackets", '\ue69d'),
    BUGSENSE("di-bugsense", '\ue68d'),
    CELLULOID("di-celluloid", '\ue66b'),
    CHROME("di-chrome", '\ue643'),
    CISCO("di-cisco", '\ue665'),
    CLOJURE("di-clojure", '\ue668'),
    CLOJURE_ALT("di-clojure_alt", '\ue66a'),
    CLOUD9("di-cloud9", '\ue69f'),
    CODA("di-coda", '\ue693'),
    CODE("di-code", '\ue696'),
    CODEIGNITER("di-codeigniter", '\ue680'),
    CODEPEN("di-codepen", '\ue616'),
    CODE_BADGE("di-code_badge", '\ue6a3'),
    CODROPS("di-codrops", '\ue62f'),
    COFFEESCRIPT("di-coffeescript", '\ue651'),
    COMPASS("di-compass", '\ue661'),
    COMPOSER("di-composer", '\ue683'),
    CREATIVECOMMONS("di-creativecommons", '\ue689'),
    CREATIVECOMMONS_BADGE("di-creativecommons_badge", '\ue68a'),
    CSS3("di-css3", '\ue649'),
    CSS3_FULL("di-css3_full", '\ue64a'),
    CSSDECK("di-cssdeck", '\ue62a'),
    CSS_TRICKS("di-css_tricks", '\ue601'),
    DART("di-dart", '\ue698'),
    DATABASE("di-database", '\ue606'),
    DEBIAN("di-debian", '\ue67d'),
    DIGITAL_OCEAN("di-digital-ocean", '\ue6ae'),
    DJANGO("di-django", '\ue61d'),
    DLANG("di-dlang", '\ue6af'),
    DOCKER("di-docker", '\ue6b0'),
    DOCTRINE("di-doctrine", '\ue674'),
    DOJO("di-dojo", '\ue61c'),
    DOTNET("di-dotnet", '\ue67f'),
    DREAMWEAVER("di-dreamweaver", '\ue69c'),
    DROPBOX("di-dropbox", '\ue607'),
    DRUPAL("di-drupal", '\ue642'),
    ECLIPSE("di-eclipse", '\ue69e'),
    EMBER("di-ember", '\ue61b'),
    ENVATO("di-envato", '\ue65d'),
    ERLANG("di-erlang", '\ue6b1'),
    EXTJS("di-extjs", '\ue68e'),
    FIREBASE("di-firebase", '\ue687'),
    FIREFOX("di-firefox", '\ue645'),
    FSHARP("di-fsharp", '\ue6a7'),
    GHOST("di-ghost", '\ue61f'),
    GHOST_SMALL("di-ghost_small", '\ue614'),
    GIT("di-git", '\ue602'),
    GITHUB("di-github", '\ue60a'),
    GITHUB_ALT("di-github_alt", '\ue608'),
    GITHUB_BADGE("di-github_badge", '\ue609'),
    GITHUB_FULL("di-github_full", '\ue617'),
    GIT_BRANCH("di-git_branch", '\ue625'),
    GIT_COMMIT("di-git_commit", '\ue629'),
    GIT_COMPARE("di-git_compare", '\ue628'),
    GIT_MERGE("di-git_merge", '\ue627'),
    GIT_PULL_REQUEST("di-git_pull_request", '\ue626'),
    GNU("di-gnu", '\ue679'),
    GO("di-go", '\ue624'),
    GOOGLE_ANALYTICS("di-google_analytics", '\ue660'),
    GOOGLE_CLOUD_PLATFORM("di-google-cloud-platform", '\ue6b2'),
    GOOGLE_DRIVE("di-google_drive", '\ue631'),
    GRAILS("di-grails", '\ue6b3'),
    GROOVY("di-groovy", '\ue675'),
    GRUNT("di-grunt", '\ue64c'),
    GULP("di-gulp", '\ue663'),
    HACKERNEWS("di-hackernews", '\ue61a'),
    HASKELL("di-haskell", '\ue677'),
    HEROKU("di-heroku", '\ue67b'),
    HTML5("di-html5", '\ue636'),
    HTML5_3D_EFFECTS("di-html5_3d_effects", '\ue635'),
    HTML5_CONNECTIVITY("di-html5_connectivity", '\ue634'),
    HTML5_DEVICE_ACCESS("di-html5_device_access", '\ue633'),
    HTML5_MULTIMEDIA("di-html5_multimedia", '\ue632'),
    IE("di-ie", '\ue644'),
    ILLUSTRATOR("di-illustrator", '\ue6b4'),
    INTELLIJ("di-intellij", '\ue6b5'),
    IONIC("di-ionic", '\ue6a9'),
    JAVA("di-java", '\ue638'),
    JAVASCRIPT("di-javascript", '\ue64e'),
    JAVASCRIPT_BADGE("di-javascript_badge", '\ue681'),
    JAVASCRIPT_SHIELD("di-javascript_shield", '\ue64f'),
    JEKYLL_SMALL("di-jekyll_small", '\ue60d'),
    JENKINS("di-jenkins", '\ue667'),
    JIRA("di-jira", '\ue65c'),
    JOOMLA("di-joomla", '\ue641'),
    JQUERY("di-jquery", '\ue650'),
    JQUERY_UI("di-jquery_ui", '\ue654'),
    KOMODO("di-komodo", '\ue692'),
    KRAKENJS("di-krakenjs", '\ue685'),
    KRAKENJS_BADGE("di-krakenjs_badge", '\ue684'),
    LARAVEL("di-laravel", '\ue63f'),
    LESS("di-less", '\ue658'),
    LINUX("di-linux", '\ue612'),
    MAGENTO("di-magento", '\ue640'),
    MAILCHIMP("di-mailchimp", '\ue69a'),
    MARKDOWN("di-markdown", '\ue63e'),
    MATERIALIZECSS("di-materializecss", '\ue6b6'),
    METEOR("di-meteor", '\ue6a5'),
    METEORFULL("di-meteorfull", '\ue6a6'),
    MITLICENCE("di-mitlicence", '\ue68b'),
    MODERNIZR("di-modernizr", '\ue620'),
    MONGODB("di-mongodb", '\ue6a4'),
    MOOTOOLS("di-mootools", '\ue690'),
    MOOTOOLS_BADGE("di-mootools_badge", '\ue68f'),
    MOZILLA("di-mozilla", '\ue686'),
    MSQL_SERVER("di-msql_server", '\ue67c'),
    MYSQL("di-mysql", '\ue604'),
    NANCY("di-nancy", '\ue666'),
    NETBEANS("di-netbeans", '\ue69b'),
    NETMAGAZINE("di-netmagazine", '\ue62e'),
    NGINX("di-nginx", '\ue676'),
    NODEJS("di-nodejs", '\ue619'),
    NODEJS_SMALL("di-nodejs_small", '\ue618'),
    NPM("di-npm", '\ue61e'),
    ONEDRIVE("di-onedrive", '\ue662'),
    OPENSHIFT("di-openshift", '\ue6b7'),
    OPENSOURCE("di-opensource", '\ue671'),
    OPERA("di-opera", '\ue646'),
    PERL("di-perl", '\ue669'),
    PHONEGAP("di-phonegap", '\ue630'),
    PHOTOSHOP("di-photoshop", '\ue6b8'),
    PHP("di-php", '\ue63d'),
    POSTGRESQL("di-postgresql", '\ue66e'),
    PROLOG("di-prolog", '\ue6a1'),
    PYTHON("di-python", '\ue63c'),
    RACKSPACE("di-rackspace", '\ue6b9'),
    RAPHAEL("di-raphael", '\ue65f'),
    RASPBERRY_PI("di-raspberry_pi", '\ue622'),
    REACT("di-react", '\ue6ba'),
    REDHAT("di-redhat", '\ue6bb'),
    REDIS("di-redis", '\ue66d'),
    REQUIREJS("di-requirejs", '\ue670'),
    RESPONSIVE("di-responsive", '\ue697'),
    RUBY("di-ruby", '\ue639'),
    RUBY_ON_RAILS("di-ruby_on_rails", '\ue63b'),
    RUBY_ROUGH("di-ruby_rough", '\ue691'),
    RUST("di-rust", '\ue6a8'),
    SAFARI("di-safari", '\ue648'),
    SASS("di-sass", '\ue64b'),
    SCALA("di-scala", '\ue637'),
    SCRIPTCS("di-scriptcs", '\ue6bc'),
    SCRUM("di-scrum", '\ue6a0'),
    SENCHATOUCH("di-senchatouch", '\ue68c'),
    SIZZLEJS("di-sizzlejs", '\ue688'),
    SMASHING_MAGAZINE("di-smashing_magazine", '\ue62d'),
    SNAP_SVG("di-snap_svg", '\ue65e'),
    SQLLITE("di-sqllite", '\ue6c4'),
    STACKOVERFLOW("di-stackoverflow", '\ue610'),
    STREAMLINE("di-streamline", '\ue605'),
    STYLUS("di-stylus", '\ue659'),
    SWIFT("di-swift", '\ue655'),
    SYMFONY("di-symfony", '\ue656'),
    SYMFONY_BADGE("di-symfony_badge", '\ue657'),
    TECHCRUNCH("di-techcrunch", '\ue62c'),
    TERMINAL("di-terminal", '\ue695'),
    TERMINAL_BADGE("di-terminal_badge", '\ue6a2'),
    TRAVIS("di-travis", '\ue67e'),
    TRELLO("di-trello", '\ue65a'),
    TYPO3("di-typo3", '\ue672'),
    UBUNTU("di-ubuntu", '\ue63a'),
    UIKIT("di-uikit", '\ue673'),
    UNITY_SMALL("di-unity_small", '\ue621'),
    VIM("di-vim", '\ue6c5'),
    VISUALSTUDIO("di-visualstudio", '\ue60c'),
    W3C("di-w3c", '\ue66c'),
    WEBPLATFORM("di-webplatform", '\ue66f'),
    WINDOWS("di-windows", '\ue60f'),
    WORDPRESS("di-wordpress", '\ue60b'),
    YAHOO("di-yahoo", '\ue615'),
    YAHOO_SMALL("di-yahoo_small", '\ue62b'),
    YEOMAN("di-yeoman", '\ue67a'),
    YII("di-yii", '\ue682'),
    ZEND("di-zend", '\ue678');

    public static Devicons findByDescription(String description) {
        for (Devicons font : values()) {
            if (font.getDescription().equals(description)) {
                return font;
            }
        }
        throw new IllegalArgumentException("Icon description '" + description + "' is invalid!");
    }

    private String description;
    private char code;

    Devicons(String description, char code) {
        this.description = description;
        this.code = code;
    }

    @Override
    public String getDescription() {
        return description;
    }

    @Override
    public char getCode() {
        return code;
    }
}